<?php
/**
 * Exceptions based on HTTP response codes
 */
class HTTPException extends Exception {}
class BadRequestException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 400);
	}
}
class UnauthorizedException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 401);
	}
}
class PaymentRequiredException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 402);
	}
}
class ForbiddenException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 403);
	}
}
class NotFoundException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 404);
	}
}
class MethodNotAllowedException extends HTTPException {
	function __construct($message) {
		parent::__construct($message,405);
	}
}
class NotAcceptableException extends HTTPException {
	function __construct($message) {
		parent::__construct($message,406);
	}
}
class RequestTimeoutException extends HTTPException {
	function __construct($message) {
		parent::__construct($message,408);
	}
}
class ConflictException extends HTTPException {
	function __construct($message) {
		parent::__construct($message,409);
	}
}
class GoneException extends HTTPException {
	function __construct($message) {
		parent::__construct($message,410);
	}
}
class LengthRequiredException extends HTTPException {
	function __construct($message) {
		parent::__construct($message,411);
	}
}
class PreconditionFailedException extends HTTPException {
	function __construct($message) {
		parent::__construct($message,412);
	}
}
class UnsupportedMediaTypeException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 415);
	}
}
class ExpectationFailedException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 417);
	}
}
class InternalServerException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 500);
	}
}
class NotImplementedException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 501);
	}
}
class GatewayException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 502);
	}
}
class ServiceUnavailableException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 503);
	}
}
class HTTPVersionException extends HTTPException {
	function __construct($message) {
		parent::__construct($message, 505);
	}
}
/**
 * Exceptions based on REST error conditions
 */
class MissingParameterRESTException extends BadRequestException {
	function __construct($param_name) {
		if(!is_array($param_name)) $param_name=array($param_name);
		$message='Missing required parameters "'.
		implode('" ,"',$param_name).
		'"';
		parent::__construct($message);
	}
}
class RegExpRESTException extends BadRequestException {
	function __construct($param_name,$regex) {
		$message='Parameter "'.$param_name.'" should match the regular expression "'.$regex.'"';
		parent::__construct($message);
	}
}
