<?php
define('NO_UURL',true);
chdir('..');

require 'REST/exceptions.php';
$_COOKIE['APISESSID']='';
try {
	require 'auth/auth.php';
	auth::init();
}
catch(GoneException $e) {}
catch(UnauthorizedException $e) {

	echo '<!DOCTYPE><html><head><title>RemoteCP</title>'.
	'<link type="text/css" href="'.URL_JQUERY.'/css/jquery-ui.css" rel="stylesheet">'.
	'<link type="text/css" href="'.DOMAIN.'/style.css" rel="stylesheet">'.
	'<script src="'.DOMAIN.'/scripts.js"></script>'.
	'<script src="'.DOMAIN.'/scripts/live.js"></script>'.
	'<script>function refreshFrames() {location.reload();}; var UURL="'.UURL.'"</script>'.
	'</head><body><div id="login-container"><div id="versions"></div><div id="buttons-main"></div>'.
	'<div id="dlg_log-in" title="'.$t->_('Log in').'" class="gui-dlg gui-dlg-fs gui-dlg-noresize">'.
	'<form name="login">'.
	$t->_('Username').': <input type="text" name="user" id="login-user"><br>'.
	$t->_('Password').': <input type="password" name="pass" id="login-pass">'.
	'</form></div></div>';


	//tabs
	echo
	'<div class="ui-tabs ui-widget ui-widget-content ui-corner-all panel">'.
		'<ul class="ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all" style="height: 26px;">'.
			'<li class="ui-state-default ui-corner-top ui-tabs-selected ui-state-active">'.
				'<a>'.$t->_('Authorize application').'</a>'.
			'</li>'.
		'</ul>'.
		'<div class="ui-tabs-panel ui-widget-content ui-corner-bottom">';
	$error=false;
	try {
		auth::set_consumer($_GET['consumer_auth']);
		//Load info
		$consumer_info=auth::get_consumer_info(auth::$consumer_id);
		$cred_info=auth::get_temporary($_GET['consumer_auth']);
	}
	catch(GoneException $e) {
		echo '<h1 class="ui-widget-header ui-corner-top" style="margin-bottom: 0">'.$t->_('Oops').'</h1>'.
		'<div class="ui-widget-content ui-corner-bottom ui-state-error">'.
		$t->_('Something went wrong. This page is no longer valid.<br>Somebody already used the token you provided.<br>Please return to the site that sent you here and try again.<br>It probably was a mistake.').
		'</div>';
		$error=true;
	}
	if($error) {}
	elseif(!session::$logged_in&&isset($_POST['authorize'])) {
		echo '<script>$(function(){notice.error("'.$t->_('Not logged in').'","'.$t->_('You have to log in before you authorize an application').'")})</script>';
	}
	elseif(isset($_POST['authorize'])) {
		try{
			if(isset($_POST['auth_time_always'])) {
				$time=NULL;
			}
			else {
				$time=(int)$_POST['auth_time_days']*24*60*60+(int)$_POST['auth_time_hours']*60*60+(int)$_POST['auth_time_mins']*60;
			}
			if(isset($_POST['time'])) {
				$time=(int)$_POST['time'];
				if($time=='') $time=NULL;
			}
			if((int)$cred_info['use']&auth::all) { //Warn again about all permissions
				echo '<h1 class="ui-widget-header ui-corner-top" style="margin-bottom: 0">'.$t->_('Are you really sure?').'</h1>'.
				'<div class="ui-widget-content ui-corner-bottom">'.
					$t->_('You are about to give an application <b>ALL</b> permissions (including deleting and creating accounts)').
					'<form method="POST"><input type="hidden" name="really_sure" value="reallysure">'.
					'<input type="hidden" name="time" value="'.htmlspecialchars($time).'">'.
					'<input type="submit" class="gui-button ui-priority-primary" name="authorize" value="'.$t->_('Grant all privileges').'">'.
					'<input type="submit" class="gui-button ui-priority-secondary" name="cancel" value="'.$t->_('Cancel').'"></form>'.
				'</div>';
			}
			if(!((int)$cred_info['use']&auth::all)||isset($_POST['really_sure'])) {
				$authkey=auth::auth_authorize(session::$guid, $_GET['consumer_auth'],$time);
				header('Location: '.$cred_info['return_url'].'?authentication_key='.$authkey);
				echo '<h1 class="ui-widget-header ui-corner-all">'.$t->_('If you are not redirected, please refresh the application window').'</h1>';
			}
		}
		catch(GoneException $e) {
			echo '<h1 class="ui-widget-header ui-corner-top" style="margin-bottom: 0">'.$t->_('Oops').'</h1>'.
			'<div class="ui-widget-content ui-corner-bottom ui-state-error">'.
				$t->_('Something went wrong. This page is no longer valid.<br>Somebody already used the token you provided.<br>Please return to the site that sent you here and try again.<br>It probably was a mistake.').
			'</div>';
		}
		catch(HTTPException $e) {
			echo 'If you are seeing this, something is really wrong!<br>'.$e->getCode().': '.$e->getMessage();
		}
	}
	elseif(isset($_POST['cancel'])) {
		auth::auth_reject($_GET['consumer_auth']);
		echo '<h1 class="ui-widget-header ui-corner-top" style="margin-bottom: 0">'.$t->_('Authorisation cancelled').'</h1>'.
		'<div class="ui-widget-content ui-corner-bottom">'.
			$t->_('Okay, we cancelled that authorisation request. Don\'t worry, the application won\'t ever know your username or password.').
		'</div>';
	}
	else {
		echo
				//Main content
				'<div>'.
					'<h1 class="ui-widget-header ui-corner-top" style="margin-bottom: 0">'.sprintf($t->_('Authorize %s to use you account?'),$consumer_info['name']).'</h1>'.
					'<div class="ui-widget-content ui-corner-bottom">'.
						//Sidebar
						'<div style="width: 500px; float:right;" class="ui-widget ui-corner-all">'.
							'<div class="ui-widget-header ui-corner-top">'.$consumer_info['name'].'</div>'.
							'<div class="ui-widget-content ui-corner-bottom">'.
								'<p>'.$t->_('By').' '.session::getUser($consumer_info['owner']).'</p>'.
								'<p>'.$consumer_info['domain'].'</p>'.
								'<p>'.$consumer_info['longdesc'].'</p>'.
							'</div>'.
						'</div>'.
						//End sidebar
						'<p>'.$t->_('This application <b style="color: green;">will be able to</b>:').
							'<ul>';
		$access_to=auth::access_list($cred_info['use']);
		foreach($access_to as $item) {
			echo '<li>'.$item.'</li>';
		}
		echo
							'</ul>'.
						'</p>'.
						'<form action="" method="POST">'.
							'<p>'.$t->_('Authorize for').': '.
								'<input type="text" name="auth_time_days" value=0 class="gui-spinner-x gui-spinner" style="width: 50px;">'.$t->_('days').
								'<input type="text" name="auth_time_hours" value=0 class="gui-spinner-24 gui-spinner" style="width: 50px;">'.$t->_('hours').
								'<input type="text" name="auth_time_mins" value=0 class="gui-spinner-60 gui-spinner" style="width: 50px;">'.$t->_('minutes').
								'<script>$(".gui-spinner-x").spinner({min:0});$(".gui-spinner-24").spinner({min:0,max:24});$(".gui-spinner-60").spinner({min:0,max:60});</script>'.
							'</p>'.
							'<p><label><input type="checkbox" name="auth_time_always" onchange="if(this.checked) {$(\'.gui-spinner\').spinner(\'disable\'); } else {$(\'.gui-spinner\').spinner(\'enable\');}">'.$t->_('Forever').'</label></p>'.
							'<input type="submit" name="authorize" class="gui-button ui-priority-primary" value="'.$t->_('Authorize app').'">'.
							'<input type="submit" name="cancel" class="gui-button ui-priority-secondary" value="'.$t->_('Cancel').'">'.
						'</form>'.
						'<p>'.$t->_('This application <b style="color: red;">will not be able to</b>:').
							'<ul>';
		$no_access_to=auth::access_list($cred_info['use'],true);
		foreach($no_access_to as $item) {
			echo '<li>'.$item.'</li>';
		}
		echo
							'<ul>'.
						'<div style="clear: both"></div>'.
					'</div>'.
				'</div>';
	}
			//End main content
	echo
		'</div>'.
	'</div>';
	//End tabs

}