<?php
define('NO_UURL',true);
chdir('..');
try {
	require 'REST/REST.php';
}
catch (UnsupportedMediaTypeException $e) {}
$_COOKIE['APISESSID']='';
try {
	require 'auth/auth.php';
	auth::init();
}
catch (UnauthorizedException $e) { //User is not yet authorized
	$data=REST::input()->getData();
	try {
		if(!isset($data['api_key'])) {
			throw new BadRequestException('You must provide an API key (api_key)');
		}
		if(!isset($data['return_url'])) {
			throw new BadRequestException('You must provide a return URL (return_url)');
		}
		if(!isset($data['use'])) {
			throw new BadRequestException('You must provide a restriction for the authentication (use)');
		}
		if($data['use']<0||$data['use']>=4096) {
			throw new BadRequestException('Use parameter should be between 0 and 4096');
		}
		$response['temporary_credentials']=auth::auth_initialize($data['api_key'], $data['return_url'],$data['use']);
		$response['redirect_url']=DOMAIN.'/api/auth/authorize.php?consumer_auth='.$response['temporary_credentials'];
		$response['use']=$data['use'];
		REST::output()->setData($response);
	}
	catch(HTTPException $ex) {
		REST::error($ex->getCode(), $ex->getMessage());
	}
}
REST::response()->send();
