<?php
$input=REST::input();
REST::load('inc/groups/groups.php');
$GID=$input->getParts(2);
switch(REST::getMethod()) {
	case REST::get:
		$nameq=$remote_connection->query('SELECT * FROM `groups_names` WHERE UPPER(`gid`)="'.strtoupper($GID).'"');
		if($nameq->num_rows!=1) throw new NotFoundException('The group with GID '.$GID.' does not exist');
		$name=$nameq->fetch_object()->name;
		$users=array();
		$usersq=$remote_connection->query('SELECT * FROM `groups` WHERE UPPER(`gid`)="'.strtoupper($GID).'"');
		while($user=$usersq->fetch_assoc()) {
			$users[]=array('user'=>$user['user'],'administrator'=>(bool)$user['admin']);
		}
		REST::output()->setData(array('name'=>$name,'users'=>$users));
		break;
	case REST::put:
		auth::granted(auth::write_db_groups,true);
		$data=$input->getData();
		REST::check()->parameter_exists('user');
		REST::check()->assure(groups::groupExists($GID),new NotFoundException('The group with GID '.$GID.' does not exist'));
		REST::check()->assure(groups::isGroupAdmin($GID),new ForbiddenException('You are not an administrator of the group with GID '.$GID));
		REST::check()->assure(session::userExists($data['user']),new NotFoundException('The user with GUID '.$data['user'].' does not exist'));
		if(groups::addUser($data['user'], $GID)) {
			REST::output()->setData(array('status'=>true));
		}
		else {
			REST::output()->setData(array('status'=>false,'errors'=>JSError::get()));
		}
		break;
	case REST::post:
		auth::granted(auth::write_db_groups,true);
		$data=$input->getData();
		REST::check()->parameter_exists('name');
		REST::check()->preg_match('/^[A-Za-z_0-9\\-\\(\\)]+$/', $data['name'],'name');
		REST::check()->assure(groups::groupExists($GID),new NotFoundException('The group with GID '.$GID.' does not exist'));
		REST::check()->assure(groups::isGroupAdmin($GID),new ForbiddenException('You are not an administrator of the group with GID '.$GID));
		$q=$remote_connection->query('UPDATE `groups_names` SET `name`=\''.$data['name'].'\' WHERE UPPER(`GID`)=\''.strtoupper($GID).'\'');
		if($q) REST::output()->setData(array('status'=>true));
		else REST::output()->setData(array('status'=>false));
		break;
	default:
		return false;
}