<?php
REST::load('inc/utils/doubleExplode.php');
switch (REST::getMethod()) {
	case REST::get:
		$settings=array();
		$settings['title']=$local_connection->query('SELECT `title` FROM `remote_databases` WHERE `key`=\''.$local_connection->escape_string(REST::input()->getParts(0)).'\'')
			->fetch_object()->title;
		$settingsq=$remote_connection->query('SELECT * FROM `_system_`');
		while($setting=$settingsq->fetch_assoc()) {
			switch($setting['key']) {
				case 'styles':
					$styles=explode('|',$setting['value']);
					break;
				case 'domains':
					$domains=explode('|',$setting['value']);
					break;
				case 'addons':
					$addons=doubleExplode('&', '=', $setting['value']);
					$sortedaddons=array();
					foreach($addons as $k=>$v) {
						array_push($sortedaddons, array('id'=>$k,'name'=>$v));
					}
					break;
				default:
					$settings[$setting['key']]=$setting['value'];
			}
		}
		$settings['styles']=$styles;
		$settings['domains']=$domains;
		$settings['addons']=$sortedaddons;
		REST::output()->setData($settings);
		break;
	case REST::post:
		auth::granted(auth::all);
		$data=REST::input()->getData();
		$parameters=array('title'=>null,'domains'=>null);
		$data=array_intersect_key($data,$parameters); //At least one key from the parameters array should be present
		REST::check()->assure(count($data)>=1, new MissingParameterRESTException(array('title','domains')));
		$q=array();
		if(isset($data['title'])) {
			REST::check()->preg_match('^[a-zA-Z0-9 -_]+$', $data['title'],'title');
			$q[]=$local_connection->query('UPDATE `remote_databases` SET `title`=\''.$local_connection->escape_string($data['title']).'\' WHERE `key`=\''.$local_connection->escape_string(REST::input()->getParts(0)).'\'');
		}
		if(isset($data['domains'])) {
			REST::load('inc/utils/validDomainName.php');
			$domains=REST::input()->decode($data['domains']);
			foreach($domains as $domain) {
				REST::check()->assure(is_valid_domain_name($domain),new BadRequestException($domain.' is not a valid domain name'));
			}
			$domains=implode('|',$domains);
			$q[]=$remote_connection->query('UPDATE `_system_` SET `value`=\''.$domains.'\' WHERE `key`=\'domains\'');
		}
		if(in_array(false, $q,true)) REST::output()->setData(array('status'=>false));
		else REST::output()->setData(array('status'=>true));
		break;
	default:
		return false;
}