<?php
switch(REST::getMethod()) {
	case REST::get:
		$sitesq=$remote_connection->query('SELECT `site_ref` FROM `system_siteinfo` GROUP BY `site_ref`');
		while($site=$sitesq->fetch_assoc()) {
			REST::output()->appendData($site['site_ref']);
		}
		break;
	case REST::put:
			auth::granted(auth::write_db_sites_new);
			REST::check()->parameter_exists('domain');
			REST::check()->parameter_exists('subdomain');
			REST::check()->parameter_exists('style');
			REST::check()->parameter_exists('language');
			REST::check()->parameter_exists('title');
			REST::check()->parameter_exists('tagline');
			REST::check()->parameter_exists('footer');
			REST::check()->parameter_exists('author');
			$data=REST::input()->getData();
			//Check domain
			$c0=$remote_connection->query('SELECT `value` FROM `_system_` WHERE `key`=\'domains\'');
			REST::check()->assure($c0->num_rows==1,new GatewayException('Remote database has invalid domain settings in _system_'));
			$available_domains=explode('|', $c0->fetch_object()->value);
			$c0->free();
			REST::check()->assure(in_array($data['domain'], $available_domains),new BadRequestException('The provided domain is not in the range of valid domains'));
			//Check subdomain
			REST::check()->preg_match('/^[a-z0-9\\-]+$/i', $data['subdomain'],'subdomain');
			$c1=$remote_connection->query('SELECT * FROM `system_domains` WHERE `url-in`=\''.$data['subdomain'].'.'.$data['domain'].'\'');
			REST::check()->assure($c1->num_rows==0,new ConflictException('This subdomain is already registered'));
			$c1->free();
			//Check style
			$c2=$remote_connection->query('SELECT `value` FROM `_system_` WHERE `key`=\'styles\'');
			if($c2->num_rows!=1) throw new GatewayException('Remote database has invalid style settings in _system_');
			$available_styles=explode('|', $c2->fetch_object()->value);
			$c2->free();
			REST::check()->assure(in_array($data['style'], $available_styles),new BadRequestException('The provided style is not in the range of valid styles'));
			//Check language
			require __DIR__.'/../../../inc/utils/languageCodes.php';
			REST::check()->assure(array_key_exists($data['language'], $languageCodes),new BadRequestException('The provided language is not in the range of valid languages'));
			//Check title
			REST::check()->assure(trim($data['title'])!='', new BadRequestException('The provided title should be at least one character'));
			//Execute registration
			REST::load('inc/utils/guid.php');
			REST::load('inc/utils/doubleExplode.php');
			$site_ref=guid();
			//Create domain link
			$x[]=$remote_connection->query('INSERT INTO `system_domains` VALUES(\''.$remote_connection->escape_string($data['subdomain'].'.'.$data['domain']).'\',NULL,\''.$site_ref.'\')');
			//Create site constants
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_TITLE\',\''.$remote_connection->escape_string(htmlspecialchars($data['title'])).'\')');
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'URL_SITE\',\'http://'.$remote_connection->escape_string($data['subdomain'].'.'.$data['domain']).'/\')');
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_AUTHOR\',\''.$remote_connection->escape_string(htmlspecialchars($data['author'])).'\')');
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_SLOGAN\',\''.$remote_connection->escape_string(htmlspecialchars($data['tagline'])).'\')');
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_CSS\',\''.$remote_connection->escape_string($data['style']).'\')');
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_LNG\',\''.$remote_connection->escape_string($data['language']).'\')');
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'SITE_FOOTER\',\''.$remote_connection->escape_string($data['footer']).'\')');
			$x[]=$remote_connection->query('INSERT INTO `system_siteinfo` VALUES(\''.$site_ref.'\',\'ADMIN_GROUP\',NULL)');

			//Create site addons index
			$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_addons` (`name` varchar(30) NOT NULL,`reference` varchar(30) NOT NULL,`status` int(1) NOT NULL default '0',`gid` char(36) NULL default NULL,`editable` int(1) NOT NULL default '1') ENGINE=MyISAM DEFAULT CHARSET=latin1");
			$q=$remote_connection->query('SELECT * FROM `_system_` WHERE `key`=\'addons\''); //Get installed addons
			$prepared_q="INSERT INTO `{$site_ref}_addons` (`name`, `reference`, `status`, `gid`, `editable`) VALUES ('CMS', 'cms', 1, NULL, 0),('Column1', 'col1', 1, NULL, 0),('Column 3', 'col3', 1, NULL, 0),('File manager', 'filemanager', 1, NULL, 0)";
			$q=$q->fetch_assoc();
			$q['value']=preg_replace('@^&?(.*)&?$@', '$1', $q['value']);
			$addons=doubleExplode('&','=',$q['value']);
			foreach($addons as $name=>$addon) {
				$prepared_q.=",('$name', '$addon', 0, NULL, 1)";
			}
			$x[]=$remote_connection->query($prepared_q); //Dump addons into table
			//Create col1 table
			$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_col1` ( `id` int(11) NOT NULL AUTO_INCREMENT, `order` int(5) NOT NULL, `title` varchar(30) NOT NULL, `content` text NOT NULL, `plugin-reference` varchar(30) DEFAULT NULL, `access` int(1) NOT NULL DEFAULT '0', PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1");
			$remote_connection->query("TRUNCATE TABLE `{$site_ref}_col1`"); //Clean table
			//Dump col1 contents into table
			//No contents
			//Create col3 table
			$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_col3` ( `id` int(11) NOT NULL AUTO_INCREMENT, `order` int(5) NOT NULL, `title` varchar(30) NOT NULL, `content` text NOT NULL, `plugin-reference` varchar(30) DEFAULT NULL, `access` int(1) NOT NULL DEFAULT '0', PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1");
			$remote_connection->query("TRUNCATE TABLE `{$site_ref}_col3`"); //Clean table
			//Dump col3 contents into table
			//No contents
			//Create pageindex table
			$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_pageindex` ( `id` int(5) NOT NULL AUTO_INCREMENT, `type` int(1) NOT NULL DEFAULT '0', `page_order` int(5) NOT NULL, `page_title` text COLLATE latin1_general_ci NOT NULL, `link` text COLLATE latin1_general_ci NOT NULL, `access` int(1) NOT NULL DEFAULT '0', `visible` int(11) NOT NULL DEFAULT '1', PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;");
			$remote_connection->query("TRUNCATE TABLE `{$site_ref}_pageindex`"); //Clean table
			//Dump pageindex contents into table
			$x[]=$remote_connection->query("INSERT INTO `{$site_ref}_pageindex` (`id`, `type`, `page_order`, `page_title`, `link`, `access`, `visible`) VALUES(1, 2, 1, 'Home', '', 0, 1)");
			//Create pages tables
			$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_pages` ( `id` int(11) NOT NULL AUTO_INCREMENT, `page_id` int(5) NOT NULL, `section_order` int(11) NOT NULL DEFAULT '1', `section_title` text COLLATE latin1_general_ci NOT NULL, `section_main` text COLLATE latin1_general_ci NOT NULL, `plugin-reference` varchar(30) COLLATE latin1_general_ci DEFAULT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci");
			$remote_connection->query("TRUNCATE TABLE `{$site_ref}_pages`"); //Clean table
			//Dump pages contents into table
			//No contents
			//Create MySQLfs index table
			$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_fs` (`path` varchar(900) NOT NULL,`filename` varchar(100) NOT NULL,`rights` int(3) unsigned zerofill NOT NULL DEFAULT '777',`owner` char(36) DEFAULT NULL,`group` char(36) DEFAULT NULL,`time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,`type` enum('d','f') NOT NULL,`mime` varchar(100) NOT NULL DEFAULT 'application/octet-stream',`size` int(11) unsigned NOT NULL DEFAULT '0',`mfi` int(11) unsigned NOT NULL AUTO_INCREMENT,UNIQUE KEY `path` (`path`,`filename`),UNIQUE KEY `mfi` (`mfi`)) ENGINE=MyISAM");
			//Dump MySQLfs primary folder
			$x[]=$remote_connection->query("INSERT INTO `{$site_ref}_fs` (`path`, `filename`, `rights`, `owner`, `group`, `time`, `type`, `mime`, `size`, `mfi`) VALUES('/', '', 777, NULL, NULL, NULL, 'd', 'application/octet-stream', 0, 1);");
			//Create MySQLfs data table
			$x[]=$remote_connection->query("CREATE TABLE `{$site_ref}_fsdata` (`id` int(11) unsigned NOT NULL AUTO_INCREMENT,`masterid` int(11) unsigned NOT NULL,`data` blob NOT NULL,PRIMARY KEY (`id`),KEY `masterid` (`masterid`)) ENGINE=MyISAM");
			//Assign admin link
			$x[]=$remote_connection->query("INSERT INTO `sites` VALUES ('".session::$guid."', '{$site_ref}', '')");
			if(in_array(false, $x,true)) REST::output()->setData(array('status'=>false));
			else REST::output()->setData(array('status'=>true,'id'=>$site_ref));
		break;
	default:
		return false;
}