<?php
class getopt {
	static private $instring='';
	static private $arguments=array();
	static private $mapped_args=array();
	static private $short_long_map=array();
	static function init() {
		$instr=$_SERVER['argv'];
		unset($instr[0]);
		$instr=array_values($instr);
		self::$arguments=$instr;
		self::$instring=implode(' ', $instr);
		self::map();
	}
	static private function map() {
		$skip_next=false;
		foreach(self::$arguments as $arg){
			if($skip_next) {
				$skip_next=false;
				continue;
			}
			if(substr($arg,0,2)=='--') { //Long argument
				$arg=substr($arg,2);
				list($key,$value)=explode('=',$arg,2);
				if(!isset($value))  {
					self::$mapped_args[$key]=true;
					continue;
				}
				self::$mapped_args[$key]=$value;
			}
			elseif(substr($arg,0,1)=='-') { //Short argument
				$arg=substr($arg,1);
				$key=$arg;
				$keylength=strlen($key);
				if($keylength>1) { //More packed shorts
					for($i=0;$i<$keylength;$i++) {
						self::$mapped_args[$key[$i]]=true;
					}
					continue;
				}
				$value=next(self::$arguments);
				if(substr($value,0,1)=='-') { //No value, but an argument
					self::$mapped_args[$key]=true;
					continue;
				}
				$skip_next=true;
				self::$mapped_args[$key]=$value;
			}
			else {
				self::$mapped_args[]=$arg;
			}
		}
	}
	static function mapShortCode($short,$long) {
		self::$short_long_map[$short]=$long;
	}
	static protected function getLongCode($short) {
		if(array_key_exists($short, self::$short_long_map)) {
			return self::$short_long_map[$short];
		}
		return false;
	}
	static protected function getShortCode($long) {
		return array_search($long, self::$short_long_map);
	}
	static function getArgument($argname) {
		if(array_key_exists($argname, self::$mapped_args)) {
			return self::$mapped_args[$argname];
		}
		elseif($argname=self::getShortCode($argname)&&array_key_exists($argname, self::$mapped_args)) { //Short code registered
			return self::$mapped_args[$argname];
		}
		return false;
	}
	static function getArguments() {
		$retarr=array();
		foreach(self::$mapped_args as $arg=>$value) {
			$long=self::getLongCode($arg);
			if($long) {
				$retarr[$long]=$value;
				continue;
			}
			$retarr[$arg]=$value;
		}
		return $retarr;
	}
}
getopt::init();
