<?php //@./build/make_installer_class.php ?>
<?php
class compressor {
	private $dirs=array();
	private $excludes=array();
	private $files=array();
	private $install_tpl=NULL;
	function __construct($install_template=NULL) {
		$this->install_tpl=file_get_contents($install_template);
	}
	function addFile($file) {
		if($this->isExcluded($file)) return;
		fwrite(STDOUT,"[inst][cp][$file]Compressing file...");
		$this->files[$file]=base64_encode(gzcompress(file_get_contents($file)));
		fwrite(STDOUT,"Done".PHP_EOL);
		
	}
	function addDir($dir) {
		fwrite(STDOUT,"[inst][cp][$dir]Adding directory...".PHP_EOL);
		$this->dirs[] = $dir;
		$files=scandir($dir);
		foreach($files as $file) {
			if($file=='.'||$file=='..'||$this->isExcluded($dir.'/'.$file)) continue;
			elseif(is_dir($dir.'/'.$file)) 
				$this->addDir($dir.'/'.$file);
			elseif(is_file($dir.'/'.$file))
				$this->addFile($dir.'/'.$file);
		}
		fwrite(STDOUT,"[inst][cp][$dir]Directory added".PHP_EOL);
	}
	function exclude($file) {
		fwrite(STDOUT,"[inst][cp][$file]Excluded file".PHP_EOL);
		$this->excludes[]=realpath($file);
	}
	private function isExcluded($file) {
		return in_array(realpath($file),$this->excludes);
	}
	function compress($outfile) {
		fwrite(STDOUT,"[inst][cp]Exporting directories".PHP_EOL);
		$dirs=var_export($this->dirs,true);
		fwrite(STDOUT,"[inst][cp]Exporting files".PHP_EOL);
		$files=var_export($this->files,true);
		fwrite(STDOUT,"[inst][cp]Creating installer code".PHP_EOL);
		$code='<'.'?php'."\n";
		$code.='$DIRECTORIES='.$dirs.';'."\n";
		$code.='$FILES='.$files.';'."\n";
		$code.='?'.'>';
		if($this->install_tpl!==NULL)
			$code.=$this->install_tpl;
		fwrite(STDOUT,"[inst][cp]Writing installer".PHP_EOL);
		file_put_contents($outfile,$code);
		fwrite(STDOUT,"[inst][cp]Done".PHP_EOL);
	}
}