<?php
/**
 * This class handles the display of errors through AJAX
 * @package javascript
 */
class JSError {
	/**
	 * Holds all errors as an array
	 */
	private static $errors=array();
	/**
	 * Add an error
	 * @param string $string The error string
	 */
	static function add($string) {
		self::$errors[]=$string;
	}
	/**
	 * Returns all errors in the right format for JS error handling
	 * @return string
	 */
	static function show() {
		if(count(self::$errors)==0)
			return "true";
		else
			return "false|".implode('|',self::$errors);
	}
	/**
	 * Counts the number of errors
	 * @return int The number of errors
	 */
	static function count() {
		return count(self::$errors);
	}
	/**
	 * Get all errors
	 * @return array Array containing all errors
	 */
	static function get() {
		return self::$errors;
	}
}