<?php //@./inc/errorhandler.php ?>
<?php
function debugErrorHandler($enum,$estring,$efile,$eline,$context) {
	if(error_reporting()===0) {
		return;
	}
	$error_mapping=array(
		E_ERROR=>'Fatal error',
		E_WARNING=>'Warning',
		E_PARSE=>'Parse error',
		E_NOTICE=>'Notice',
		E_USER_ERROR=>'Fatal error',
		E_USER_WARNING=>'Warning',
		E_USER_NOTICE=>'Notice',
		E_STRICT=>'Strict warning',
		E_RECOVERABLE_ERROR=>'Recoverable error',
		E_DEPRECATED=>'Deprecated',
		E_USER_DEPRECATED=>'Deprecated'
	);
	$fatal=array(E_ERROR,E_USER_ERROR,E_RECOVERABLE_ERROR);
	@header('HTTP/1.1 500'); //Send server error header
	fwrite(fopen('error.log','a'),$error_mapping[$enum].': '.$estring.' in '.$efile.' on line '.$eline.PHP_EOL);
	echo '<hr><b>'.$error_mapping[$enum].':</b> '.$estring.' in <b>'.$efile.'</b> on line <b>'.$eline.'</b><br>	<b>Context:</b><pre>';
	var_dump($context);
	echo '</pre><br><b>Backtrace:</b><pre>';
	$debug=debug_backtrace(false);
	unset($debug[0]);
	var_dump($debug);
	echo '</pre><hr>';
	if(in_array($enum,$fatal)) exit(1);
	return;
}
function mainErrorHandler($enum,$estring,$efile,$eline,$context) {
	if(error_reporting()===0) {
		return;
	}
	$error_mapping=array(
		E_ERROR=>'Fatal error',
		E_WARNING=>'Warning',
		E_PARSE=>'Parse error',
		E_NOTICE=>'Notice',
		E_USER_ERROR=>'Fatal error',
		E_USER_WARNING=>'Warning',
		E_USER_NOTICE=>'Notice',
		E_STRICT=>'Strict warning',
		E_RECOVERABLE_ERROR=>'Recoverable error',
		E_DEPRECATED=>'Deprecated',
		E_USER_DEPRECATED=>'Deprecated'
	);
	$fatal=array(E_ERROR,E_USER_ERROR,E_RECOVERABLE_ERROR);
	@header('HTTP/1.1 500'); //Send server error header
	echo '<hr><b>'.$error_mapping[$enum].':</b> '.$estring.'<hr>';
	if(in_array($enum,$fatal)) exit(1);
	return;
}
set_error_handler('mainErrorHandler',E_ALL);
if(defined('__DEBUG__')&&__DEBUG__) set_error_handler('debugErrorHandler',-1);