<?php //@./inc/httpmysql/fsock.php ?>
<?php
/*********************************\
| HTTPMySQL - fsockopen connector |
\*********************************/
/**
 * Connector for HTTPMySQL
 * @package remote
 * @subpackage httpmysql
 */
class HTTPMySQL_connect {
	protected $type='fsockopen';
	/**
	 * Performs a post request to a remote server
	 * @param string $host The host where you want to connect to
	 * @param string $url The URI on the host to the file
	 * @param string $data The raw post string
	 * @return string Data returned by the remote file
	 */
	protected function post_request($host,$url, $data){
		$fp = fsockopen($host, 80);
		if(!$fp) {
			trigger_error('Error opening connection to '.$host,E_USER_WARNING);
			return false;
		}
		$out = "POST $url HTTP/1.1\r\n";
		$out .= "Host: $host\r\n";
		$out .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$out .= "Content-Length: ".strlen($data)."\r\n";
		$out .= "Connection: Close\r\n\r\n";
		$out .= $data;
		fwrite($fp, $out);
		$ret="";
		while (!feof($fp)) {
			$ret.= fgets($fp,1024);
		}
		fclose($fp);
		$headers=substr($ret,0,strpos($ret,"\r\n\r\n"));
		$headers=$this->parse_headers($headers);
		
		$ret=substr($ret,strpos($ret,"\r\n\r\n")+4);
		if(substr($headers[0],9,3)!=200) trigger_error('Error establishing connection to http://'.$host.'/'.$url.': Server returned '.$headers[0],E_USER_WARNING);
		return $ret;
	}
	private function parse_headers($headers){
		$ret=array();
		$headers=explode("\r\n",$headers);
		foreach($headers as $header) {
			$header=explode(': ',$header);
			if(!isset($header[1])) $ret[]=$header[0];
			else $ret[$header[0]]=$header[1];
		}
		return $ret;
	}
}