<?php //@./inc/sqlsess/sqlsess.php ?>
<?php
/**
 * inc/sqlsess/sqlsess.php
 * Stores sessions in a MySQL table with
 * php session functions
 */
class SQLSESS {
	private $connection;
	private $table;
	private $cookname='SQLSESSID';
	function SQLSESS($database,$tbl) {
		$this->connection=$database;
		$this->table=$tbl;
		//Clean old sessions
		$this->connection->query("DELETE FROM `$this->table` WHERE `created` < '".date('Y-m-d H:i:s',time()-30*60)."'"); //30 min deletion timeout
	}
	/**
	 * bool session_start( void )
	 * Starts the SQLSESS session
	 */
	function session_start() {
		if(!isset($_COOKIE[$this->cookname])||$this->connection->query("SELECT * FROM `$this->table` WHERE `sessid`='".$_COOKIE[$this->cookname]."'")->num_rows==0) {
			$code=md5(mt_rand());
			$this->setcookie($this->cookname,$code);
			$_COOKIE[$this->cookname]=$code;
			return $this->connection->query("INSERT INTO `$this->table` VALUES('$code',NULL,'')");
		}
		else {
			$id=$_COOKIE[$this->cookname];
			$c=$this->connection->query("SELECT * FROM `$this->table` WHERE `sessid`='$id'");
			$count= $c->num_rows;
			$c->free();
			return ($count==1);
		}
	}
	/**
	 * array session_get_contents( void )
	 * Returns an array with the session's contents
	 */
	function session_get_contents() {
		$id=$_COOKIE[$this->cookname];
		$c=$this->connection->query("SELECT * FROM `$this->table` WHERE `sessid`='$id'");
		$ret=$c->fetch_assoc();
		$c->free();
		$ret=unserialize($ret['data']);
		return $ret;
	}
	/**
	 * string session_id( [string $id ] )
	 * session_id() is used to get or set the session id for the current session.
	 */
	function session_id($id=NULL) {
		if($id===NULL) {
			return $_COOKIE[$this->cookname];
		}
		else {
			$this->setcookie($this->cookname,$id);
			$_COOKIE[$this->cookname]=$id;
			return $this->connection->query("INSERT INTO `$this->table` VALUES('$id',NULL,'')");
		}
	}
	/**
	 * string session_name( [string $newname] )
	 * session_name() returns the name of the current session. If name is given, session_name() will update the session name and return the old session name.
	 */
	function session_name($newname=NULL) {
		if($newname===NULL) {
			return $this->cookname;
		}
		else {
			$old=$this->cookname;
			$this->cookname=$newname;
			return $old;
		}
	}
	/**
	 * bool session_regenerate_id( void )
	 * session_regenerate_id() will replace the current session id with a new one, and keep the current session information. 
	 */
	function session_regenerate_id() {
		$oldid=$_COOKIE[$this->cookname];
		$newid=md5(mt_rand());
		$this->setcookie($this->cookname,$newid);
		$_COOKIE[$this->cookname]=$newid;
		return $this->connection->query("UPDATE `$this->table` SET `sessid` = '$newid' WHERE `sessid`='$oldid'");
	}
	/**
	 * void session_unset( void )
	 * The session_unset() function frees all session variables currently registered. 
	 */
	function session_unset() {
		$id=$_COOKIE[$this->cookname];
		$data=serialize(array());
		$this->connection->query("UPDATE `$this->table` SET `data` = '$data' WHERE `sessid`='$id'");
	}
	/**
	 * bool session_destroy( void )
	 * session_destroy() destroys all of the data associated with the current session.
	 */
	function session_destroy() {
		$id=$_COOKIE[$this->cookname];
		return $this->connection->query("DELETE FROM TABLE `$this->table` WHERE `sessid`='$id'");
	}
	function save_session($sess) {
		$data=serialize($sess);
		$id=$_COOKIE[$this->cookname];
		return $this->connection->query("UPDATE `$this->table` SET `data` = '$data' WHERE `sessid`='$id'");
	}
	/**
	 * private setcookie( string $name, string $value )
	 * Internal function to set SQLSESS cookies
	 */
	private function setcookie($name,$value) {
		setcookie($name,$value,0,'/');
	}
	function __destroy() {
		$this->save_session($_SESSION);
		$this->connection->close();
	}
}
?>