<?php
/**
 * Formats the time x-time ago (1 second ago, 2 hours ago,...)
 * @param int $original Unix-time
 * @author ViralPatel (http://viralpatel.net/blogs/2009/06/twitter-like-n-min-sec-ago-timestamp-in-php-mysql.html)
 */
function time_ago($original) {
	global $t;
	// array of time period chunks
	$names_sing = array(
	array(60 * 60 * 24 * 365 , $t->_('year')),
	array(60 * 60 * 24 * 30 , $t->_('month')),
	array(60 * 60 * 24 * 7, $t->_('week')),
	array(60 * 60 * 24 , $t->_('day')),
	array(60 * 60 , $t->_('hour')),
	array(60 , $t->_('minute')),
	array(1 , $t->_('seconds'))
	);
	$names_pl = array(
	array(60 * 60 * 24 * 365 , $t->_('years')),
	array(60 * 60 * 24 * 30 , $t->_('months')),
	array(60 * 60 * 24 * 7, $t->_('weeks')),
	array(60 * 60 * 24 , $t->_('days')),
	array(60 * 60 , $t->_('hours')),
	array(60 , $t->_('minutes')),
	array(1 , $t->_('seconds'))
	);
	$today = time(); /* Current unix time */
	$since = $today - $original;
	// $j saves performing the count function each time around the loop
	for($i = 0, $j = count($names_sing); $i < $j; $i++) {
		$seconds = $names_sing[$i][0];
		$nameid = $i;
		// finding the biggest chunk (if the chunk fits, break)
		if (($count = floor($since / $seconds)) != 0) {
			break;
		}
	}
	$print = ($count == 1) ? '1 '.$names_sing[$nameid][1] : $count.' '.$names_pl[$nameid][1];
	if ($i + 1 < $j) {
		// now getting the second item
		$seconds2 = $names_sing[$i + 1][0];
		$nameid2 = $i+1;
		// add second item if its greater than 0
		if (($count2 = floor(($since - ($seconds * $count)) / $seconds2)) != 0) {
			$print .=', '.(($count2 == 1) ? '1 '.$names_sing[$nameid2][1] : $count2.' '.$names_pl[$nameid2][1]);
		}
	}
	return $print.' '.$t->_('ago');
}