/*
	Simple OpenID Plugin
	http://code.google.com/p/openid-selector/
	
	This code is licensed under the New BSD License.
	Edited 2011-06-16 https://launchpad.net/remotecp-panel (Added PHP translations)
*/

var providers_large = {
	google : {
		name : 'Google',
		url : 'https://www.google.com/accounts/o8/id'
	},
	yahoo : {
		name : 'Yahoo',
		url : 'http://me.yahoo.com/'
	},
	aol : {
		name : 'AOL',
		label : '<?php echo $t->_('Enter your AOL screenname.'); ?>',
		url : 'http://openid.aol.com/{username}'
	},
	myopenid : {
		name : 'MyOpenID',
		label : '<?php echo $t->_('Enter your MyOpenID username.'); ?>',
		url : 'http://{username}.myopenid.com/'
	},
	openid : {
		name : 'OpenID',
		label : '<?php echo $t->_('Enter your OpenID.'); ?>',
		url : null
	}
};

var providers_small = {
	livejournal : {
		name : 'LiveJournal',
		label : '<?php echo $t->_('Enter your Livejournal username.'); ?>',
		url : 'http://{username}.livejournal.com/'
	},
	/* flickr: {
		name: 'Flickr',        
		label: '<?php echo $t->_('Enter your Flickr username.'); ?>',
		url: 'http://flickr.com/{username}/'
	}, */
	/* technorati: {
		name: 'Technorati',
		label: '<?php echo $t->_('Enter your Technorati username.'); ?>',
		url: 'http://technorati.com/people/technorati/{username}/'
	}, */
	wordpress : {
		name : 'Wordpress',
		label : '<?php echo $t->_('Enter your Wordpress.com username.'); ?>',
		url : 'http://{username}.wordpress.com/'
	},
	blogger : {
		name : 'Blogger',
		label : '<?php echo $t->_('Your Blogger account'); ?>',
		url : 'http://{username}.blogspot.com/'
	},
	verisign : {
		name : 'Verisign',
		label : '<?php echo $t->_('Your Verisign username'); ?>',
		url : 'http://{username}.pip.verisignlabs.com/'
	},
	/* vidoop: {
		name: 'Vidoop',
		label: '<?php echo $t->_('Your Vidoop username'); ?>',
		url: 'http://{username}.myvidoop.com/'
	}, */

	claimid : {
		name : 'ClaimID',
		label : '<?php echo $t->_('Your ClaimID username'); ?>',
		url : 'http://claimid.com/{username}'
	},
	clickpass : {
		name : 'ClickPass',
		label : '<?php echo $t->_('Enter your ClickPass username'); ?>',
		url : 'http://clickpass.com/public/{username}'
	},
	google_profile : {
		name : 'Google Profile',
		label : '<?php echo $t->_('Enter your Google Profile username'); ?>',
		url : 'http://www.google.com/profiles/{username}'
	},
	launchpad: {
		name: 'Launchpad',
		label: '<?php echo $t->_('Your Launchpad username'); ?>',
		url: 'https://launchpad.net/~{username}'
	}
};

openid.locale = 'en';
openid.sprite = 'en'; // reused in german& japan localization
openid.signin_text = '<?php echo $t->_('Sign-In'); ?>';
openid.image_title = '<?php echo sprintf($t->_('Log in with %s'),'{provider}'); ?>';
openid.img_path = '<?php echo DOMAIN; ?>/static/images/openid/';
