/**
 * jQuery static function extensions.
 * @author Karl Varga (http://kjvarga.blogspot.com/2009/06/jquery-plugin-to-escape-css-selector.html)
 */
 
jQuery.extend(jQuery, {
  /**
   * Escape all special jQuery CSS selector characters in *selector*.
   * Useful when you have a class or id which contains special characters
   * which you need to include in a selector.
   * @
   */
  escapeSelector: (function() {
    var specials = [
      '#', '&', '~', '=', '>', 
      "'", ':', '"', '!', ';', ','
    ];
    var regexSpecials = [
      '.', '*', '+', '|', '[', ']', '(', ')', '/', '^', '$'
    ];
    var sRE = new RegExp(
      '(' + specials.join('|') + '|\\' + regexSpecials.join('|\\') + ')', 'g'
    );

    return function(selector) {
    	selector=selector.toString();
      return selector.replace(sRE, '\\$1');
    };
  })()
});